Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet
Interface HandlerMapping

All Known Implementing Classes:
  AbstractControllerUrlHandlerMapping, AbstractDetectingUrlHandlerMapping, AbstractHandlerMapping, AbstractHandlerMethodMapping, AbstractUrlHandlerMapping, BeanNameUrlHandlerMapping, ControllerBeanNameHandlerMapping, ControllerClassNameHandlerMapping, DefaultAnnotationHandlerMapping, RequestMappingHandlerMapping, RequestMappingInfoHandlerMapping, SimpleUrlHandlerMapping

    public interface HandlerMapping

Interface to be implemented by objects that define a mapping between requests and handler objects.

This class can be implemented by application developers, although this is not necessary, as `BeanNameUrlHandlerMapping` and `SimpleUrlHandlerMapping` are included in the framework. The former is the default if no HandlerMapping bean is registered in the application context.

HandlerMapping implementations can support mapped interceptors but do not have to. A handler will always be wrapped in a `HandlerExecutionChain` instance, optionally accompanied by some `HandlerInterceptor` instances. The DispatcherServlet will first call each HandlerInterceptor's `preHandle` method in the given order, finally invoking the handler itself if all `preHandle` methods have returned `true`.

The ability to parameterize this mapping is a powerful and unusual capability of this MVC framework. For example, it is possible to write a custom mapping based on session state, cookie state or many other variables. No other MVC framework seems to be equally flexible.

Note: Implementations can implement the `Ordered` interface to be able to specify a sorting order and thus a priority for getting applied by DispatcherServlet. Non-Ordered instances get treated as lowest priority.

Author:
  Rod Johnson, Juergen Hoeller
See Also:
  `Ordered`, `AbstractHandlerMapping`, `BeanNameUrlHandlerMapping`, `SimpleUrlHandlerMapping`

Field Summary
`static java.lang.String` | `BEST_MATCHING_PATTERN_ATTRIBUTE` Name of the `HttpServletRequest` attribute that contains the best matching pattern within the handler mapping.
`static java.lang.String` | `INTROSPECT_TYPE_LEVEL_MAPPING` Name of the boolean `HttpServletRequest` attribute that indicates whether type-level mappings should be inspected.
`static java.lang.String` | `PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE` Name of the `HttpServletRequest` attribute that contains the path within the handler mapping, in case of a pattern match, or the full relevant URI (typically within the DispatcherServlet's mapping) else.
`static java.lang.String` | `PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE` Name of the `HttpServletRequest` attribute that contains the set of producible MediaTypes applicable to the mapped handler.
`static java.lang.String` | `URI_TEMPLATE_VARIABLES_ATTRIBUTE` Name of the `HttpServletRequest` attribute that contains the URI templates map, mapping variable names to values.

Method Summary
`HandlerExecutionChain` | `getHandler(javax.servlet.http.HttpServletRequest request)` Return a handler and any interceptors for this request.

Field Detail

### PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE

    static final java.lang.String PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE

  Name of the `HttpServletRequest` attribute that contains the path within the handler mapping, in case of a pattern match, or the full relevant URI (typically within the DispatcherServlet's mapping) else.

  Note: This attribute is not required to be supported by all HandlerMapping implementations. URL-based HandlerMappings will typically support it, but handlers should not necessarily expect this request attribute to be present in all scenarios.

### BEST_MATCHING_PATTERN_ATTRIBUTE

    static final java.lang.String BEST_MATCHING_PATTERN_ATTRIBUTE

  Name of the `HttpServletRequest` attribute that contains the best matching pattern within the handler mapping.

  Note: This attribute is not required to be supported by all HandlerMapping implementations. URL-based HandlerMappings will typically support it, but handlers should not necessarily expect this request attribute to be present in all scenarios.

### INTROSPECT_TYPE_LEVEL_MAPPING

    static final java.lang.String INTROSPECT_TYPE_LEVEL_MAPPING

  Name of the boolean `HttpServletRequest` attribute that indicates whether type-level mappings should be inspected.

  Note: This attribute is not required to be supported by all HandlerMapping implementations.

### URI_TEMPLATE_VARIABLES_ATTRIBUTE

    static final java.lang.String URI_TEMPLATE_VARIABLES_ATTRIBUTE

  Name of the `HttpServletRequest` attribute that contains the URI templates map, mapping variable names to values.

  Note: This attribute is not required to be supported by all HandlerMapping implementations. URL-based HandlerMappings will typically support it, but handlers should not necessarily expect this request attribute to be present in all scenarios.

### PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE

    static final java.lang.String PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE

  Name of the `HttpServletRequest` attribute that contains the set of producible MediaTypes applicable to the mapped handler.

  Note: This attribute is not required to be supported by all HandlerMapping implementations. Handlers should not necessarily expect this request attribute to be present in all scenarios.

Method Detail

### getHandler

    HandlerExecutionChain getHandler(javax.servlet.http.HttpServletRequest request)
                                     throws java.lang.Exception

  Return a handler and any interceptors for this request. The choice may be made on request URL, session state, or any factor the implementing class chooses.

  The returned HandlerExecutionChain contains a handler Object, rather than even a tag interface, so that handlers are not constrained in any way. For example, a HandlerAdapter could be written to allow another framework's handler objects to be used.

  Returns `null` if no match was found. This is not an error. The DispatcherServlet will query all registered HandlerMapping beans to find a match, and only decide there is an error if none can find a handler.

  Parameters:
    `request` - current HTTP request
  Returns:
    a HandlerExecutionChain instance containing handler object and any interceptors, or `null` if no mapping found
  Throws:
    `java.lang.Exception` - if there is an internal error

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD